#!/bin/bash

dates=('20201005 20201006 20201007 20201008 20201009 20201105 20201106 20201107 20201108 20201109 20201205 20201206 20201207 20201208 20201209')

currdir=/ships19/grain/jcintineo/GLM/

sat=goes_west

if [[ "${sat}" == "goes_west" ]]; then
  urlRoot=https://lightningdev.umd.edu/feng_data_sharing/213_g17_glmgrid_arch/
elif [[ "${sat}" == "goes_east" ]]; then
  urlRoot=https://lightningdev.umd.edu/feng_data_sharing/113_g16_glmgrid_arch/
else
  echo "must be goes_east or goes_west"
  exit
fi

mkdir -p $currdir/$sat/FD/
for date in $dates; do

  cd $currdir/$sat/FD/

  jdate=$(date +%Y%j --date=${date})
  year=$(date +%Y --date=${date})  

  echo $year $date $jdate

  mkdir -p $year/$date/5min
  cd $year/$date/5min

  #is it --cut-dirs 4 or 5? make sure to check. 4 worked for goes_east but 5 for goes_west??
  wget --no-parent --no-host-directories --cut-dirs 5 -R "index.html*" -r ${urlRoot}/${year}/${jdate}/ 

done
