import netCDF4
from lightningcast import utils
import numpy as np

# file = '/apollo/grain/common/GOESR_CONUS_RT_DATA/geocat/l1_data/geocatL1.GOES-16.CONUS.2022031.104130.hdf'
# datasets,_ = utils.read_hdf_sd(file,['pixel_surface_type'])
# sfctype = datasets['pixel_surface_type']['data']
# print(np.mean(sfctype),np.std(sfctype))
# sys.exit()
# file='/apollo/grain/saved_probsevere_data/lightning/2021/20211001/GLM/goes_west/agg/20211001-120100.netcdf'
# file='/arcdata/goes/grb/goes16/2022/2022_01_01_001/abi/L1b/RadC/OR_ABI-L1b-RadC-M6C13_G16_s20220011201173_e20220011203557_c20220011204012.nc'
# file='/arcdata/goes/grb/goes16/2022/2022_10_01_274/abi/L1b/RadF/OR_ABI-L1b-RadF-M6C13_G16_s20222741800202_e20222741809521_c20222741809578.nc'
file = "/arcdata/goes/grb/goes17/2022/2022_09_02_245/abi/L1b/RadF/OR_ABI-L1b-RadF-M6C13_G17_s20222452330319_e20222452339397_c20222452339440.nc"
nc = netCDF4.Dataset(file, "r")

data = {}
data["x"] = {
    "atts": {
        "units": "rad",
        "axis": "X",
        "long_name": "GOES fixed grid projection x-coordinate",
        "standard_name": "projection_x_coordinate",
    }
}
data["x"]["data"] = nc.variables["x"][:].astype(np.float32)
data["x"]["dims"] = ("x",)

data["y"] = {
    "atts": {
        "units": "rad",
        "axis": "Y",
        "long_name": "GOES fixed grid projection y-coordinate",
        "standard_name": "projection_y_coordinate",
    }
}
data["y"]["data"] = nc.variables["y"][:].astype(np.float32)
data["y"]["dims"] = ("y",)

gip = nc.variables["goes_imager_projection"]

data["goes_imager_projection"] = {"atts": {}, "dims": ("g",)}
data["goes_imager_projection"]["data"] = 1

for att in gip.ncattrs():
    data["goes_imager_projection"]["atts"][att] = gip.getncattr(att)
nc.close()

# surface type
# data['pixel_surface_type']={'atts':[],'data':sfctype,'dims':('y','x')}

dims = {"x": len(data["x"]["data"]), "y": len(data["y"]["data"]), "g": 1}

global_atts = {"satellite": "GOES_GLM_West"}

utils.write_netcdf(
    "/home/jcintineo/lightningcast/src/static/GOES_West_FD.nc",
    data,
    dims,
    atts=global_atts,
)


# test

# _,ny,nx,lon,lat = utils.get_area_definition('foo.nc',return_latlons=True)

# print(ny,nx)
# import matplotlib.pyplot as plt
# plt.imshow(lat)
# plt.show()
# plt.imshow(lon)
# plt.show()
