import pandas as pd


def make_scaling_values(channels):

    datasets = {
        "CH02": {
            "atts": {
                "desc": "0.65-micron refl from ABI",
                "units": "dimensionless",
                "mean": 0.087134,
                "std": 0.15314,
            }
        },
        "CH05": {
            "atts": {
                "desc": "1.6-micron refl from ABI",
                "units": "dimensionless",
                "mean": 0.047332,
                "std": 0.0834376,
            }
        },
        "CH06": {
            "atts": {
                "desc": "2.26-micron refl from ABI",
                "units": "dimensionless",
                "mean": 0.04413,
                "std": 0.080274,
            }
        },
        "CH08": {
            "atts": {
                "desc": "6.2-micron BT from ABI",
                "units": "K",
                "mean": 234.73875,
                "std": 6.4855,
            }
        },
        "CH10": {
            "atts": {
                "desc": "7.3-micron BT from ABI",
                "units": "K",
                "mean": 252.71758,
                "std": 11.06057,
            }
        },
        "CH11": {
            "atts": {
                "desc": "8.2-micron BT from ABI",
                "units": "K",
                "mean": 274.36105,
                "std": 21.69784,
            }
        },
        "CH13": {
            "atts": {
                "desc": "10.3-micron BT from ABI",
                "units": "K",
                "mean": 270.930,
                "std": 25.9126,
            }
        },
        "CH15": {
            "atts": {
                "desc": "12.4-micron BT from ABI",
                "units": "K",
                "mean": 273.168,
                "std": 19.9895,
            }
        },
        "CH16": {
            "atts": {
                "desc": "13.3-micron BT from ABI",
                "units": "K",
                "mean": 260.5381,
                "std": 17.2468,
            }
        },
    }
    scaling_values = pd.DataFrame(columns=["mean", "std"])
    for ch in channels:
        scaling_values.loc[ch] = (
            datasets[ch]["atts"]["mean"],
            datasets[ch]["atts"]["std"],
        )

    return scaling_values
