import numpy as np
import matplotlib.pyplot as plt
import pickle
import os, sys

picklefile = "/ships19/grain/probsevere/LC/samplelists/train_2019_water-only.pkl"

# set up data container
patchlen = 128  # pixels, using 2-km data as reference
hs = patchlen // 2
Xs = np.arange(hs, 2500 - hs, patchlen)
Ys = np.arange(hs, 1500 - hs, patchlen)

patches = np.zeros((len(Ys), len(Xs)), dtype=int)

plist = pickle.load(open(picklefile, "rb"))
for vv in plist:
    basefile = os.path.basename(vv)  # 20190330-1622_Y576-X1088.bmp
    y = int(basefile.split("_Y")[1].split("-")[0])
    x = int(basefile.split("-X")[1].split(".")[0])

    yidx = (np.abs(Ys - y)).argmin()
    xidx = (np.abs(Xs - x)).argmin()

    patches[yidx, xidx] += 1

plt.imshow(patches, vmin=0, vmax=patches.max(), cmap="jet")
plt.colorbar(location="bottom")
setname = "validation set" if ("val_2019" in picklefile) else "training set"
plt.title(f"Number of patches for {setname}")

plt.show()
