#!/usr/bin/perl -w

# -------------------------------------------------------------------------
#
# REST Nov 2006
#
# Look for '-i' inputs in all conf file in directory, generate a graphviz
# graph file.  Requires the graphviz package
# -------------------------------------------------------------------------

package w2run;
use strict;

Main: {
  my($machine, $lsline, $fileline, $url, $buffer);
  $buffer=<<ENDHEADER;
/* Autogenerated by makegraph.pl */
digraph unix {
  node [color=lightblue2, style=filled];
  /* Nodes follow: */
ENDHEADER

# From ls, find list of 'w2alg.conf.X' files
  if (open (LS_PIPE, "ls -l |")){
    while ($lsline = <LS_PIPE>){
      if ($lsline =~ /.*(w2alg\.conf\.)(.*)\n/){
         $machine = $2;
        print "File found:'$1$2' Machine is $2 ";
         if (open (CURRENT, "<". "$1$2")){
           print " (read successfully)\n";

# Read the current file, looking for '-i' lines.  These will be graph nodes...
    my($found, $extra);
    $found = 0;
    while($fileline = <CURRENT>){
      
# Assume MACHINE name before any -i
      if ($fileline =~ /set[ ]+MACHINE[ ]+\"([^\.]*)/i){
        $machine = $1;
        print "Real MACHINE is '$1'\n";
        $found = 1;
      }
# Only add if we found real machine name
      if ($found){

      if ($fileline =~ /.*-i (.*)/){
        $url = $1;
# Format of '-i' line assumed as "xmllb:name:path"
        if ($url =~ /xmllb:(.[^ ]*):([^ ]*)\//){  # xmllb:name:
           print "$machine gets input from $1\n";
       #    $extra = "[label = \"$2\"]";
         $extra = "";
           $buffer .= "\"$1\" -> \"$machine\" $extra;\n";
        }elsif ($url =~ /\//){
          # print "$machine gets input from self\n";
          # $extra = "[label = \"self\]";
          # $buffer .= "\"$machine\" -> \"$machine\" $extra;\n";
        }
      }

      }
    }
    close(CURRENT);

         }else{
           print " (NOT READABLE)\n";
         }
      }
    }
  }
  close (LS_PIPE);
  $buffer.=<<ENDFOOTER;
}
ENDFOOTER
#print "OUTPUT:\n";
#print $buffer; 
# Write buffer to "graph.dot"...
if (open (OUTPUT, ">". "graph.dot")){
   print OUTPUT $buffer;
   close OUTPUT;
}
# Assuming graphviz installed...
print "Trying to generate png using graphviz....\n";
`dot -Tpng graph.dot -o graph.png`
}

