#!/bin/bash

dates=('20200705 20200706 20200707 20200708 20200709 20200805 20200806 20200807 20200808 20200809 20200905 20200906 20200907 20200908 20200909')

#-sh 2500 3200 for GOES East "offshore"
#-sh 2500 3000 for GOES West large sector
sat=goes_west
if [[ "${sat}" == "goes_west" ]]; then
  shape="-sh 2500 3000"
  modeldir=${PLTG}/lightningcast/static/GOES-West/
elif [[ "${sat}" == "goes_east" ]]; then
  shape="-sh 2500 3200"
  modeldir=${PLTG}/lightningcast/static/
else
  echo "sat must be goes_east or goes_west"
  exit
fi

for date in $dates; do

  sl=$(ls /ships19/grain/jcintineo/GLM/offshore_lists/${sat}/*${date}*.pkl)
  echo $sl

  python tf_eval.py -i ${modeldir} -o /ships19/grain/jcintineo/GLM/${sat}/FD/2020/${date}/validation/ ${shape} -sl $sl -s

done

