import numpy as np
import matplotlib.pyplot as plt
import glob
import pickle
import os, sys

# get number of test date-time samples
test_counts = []
samplelist_dir = "/ships19/grain/jcintineo/GLM/offshore_lists/goes_west/"  # goes_east/CONUS/' #offshore_lists/goes_east/'
for month in np.arange(1, 13):
    month = str(month).zfill(2)
    test_samplelists = glob.glob(
        f"{samplelist_dir}/samplelist_s2020{month}*.pkl"
    )  # samplelist_s2020{month}*.pkl') G16*2020{month}*.pkl
    nsamples = 0
    for ts in test_samplelists:
        f = pickle.load(open(ts, "rb"))
        nsamples += len(f)
    test_counts.append(nsamples)
print("test_counts", np.sum(test_counts))

N = 12
train_counts = (342, 711, 731, 2206, 4397, 4849, 5793, 5695, 5127, 1453, 80, 418)
print("train_counts", np.sum(train_counts))

ind = np.arange(N)  # the x locations for the groups
width = 0.25  # the width of the bars

fig, ax = plt.subplots()
rects1 = ax.bar(ind, train_counts, width, color="r")

val_counts = (0, 168, 328, 863, 1275, 1481, 1667, 1690, 1501, 195, 165, 607)
print("val_counts", np.sum(val_counts))
sys.exit()

rects2 = ax.bar(ind + width, val_counts, width, color="y")

rects3 = ax.bar(ind + width * 2, test_counts, width, color="blue")

# add some text for labels, title and axes ticks
ax.set_ylabel("Count of unique date-times")
ax.set_title("Dataset Counts")
ax.set_xticks(ind + width / 1)
ax.set_xticklabels(
    ("Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec")
)
ax.yaxis.grid(True, linestyle=":")

ax.legend(
    (rects1[0], rects2[0], rects3[0]),
    ("training (2019)", "validation (2019)", "testing (2020)"),
)


def autolabel(rects):
    """
    Attach a text label above each bar displaying its height
    """
    for rect in rects:
        height = rect.get_height()
        ax.text(
            rect.get_x() + rect.get_width() / 2.0,
            1.05 * height,
            "%d" % int(height),
            ha="center",
            va="bottom",
        )


# autolabel(rects1)
# autolabel(rects2)

# plt.show()
plt.savefig("trainvaltest.png", bbox_inches="tight", dpi=300)
